package com.zt.plat.module.base.service.tmpltp;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.framework.security.core.util.SecurityFrameworkUtils;
import com.zt.plat.module.base.controller.admin.templtp.vo.TemplateInstanceDataPageReqVO;
import com.zt.plat.module.base.controller.admin.templtp.vo.TemplateInstanceDataRespVO;
import com.zt.plat.module.base.controller.admin.templtp.vo.TemplateInstanceDataSaveReqVO;
import com.zt.plat.module.base.dal.dataobject.tmpltp.TemplateInstanceDataDO;
import com.zt.plat.module.base.dal.mysql.tmpltp.TemplateInstanceDataMapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;

import java.util.*;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;



import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.diffList;
import static com.zt.plat.module.base.enums.ErrorCodeConstants.*;
import static com.zt.plat.module.tmpltp.enums.ErrorCodeConstants.*;
import static com.zt.plat.module.tmpltp.enums.ErrorCodeConstants.TEMPLATE_INSTANCE_DATA_NOT_EXISTS;

/**
 * 实例字段值 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
@Slf4j
public class TemplateInstanceDataServiceImpl implements TemplateInstanceDataService {

    @Resource
    private TemplateInstanceDataMapper templateInstanceDataMapper;

    @Override
    public TemplateInstanceDataRespVO createTemplateInstanceData(TemplateInstanceDataSaveReqVO createReqVO) {
        //判断当前标识字段在数据库中是否存在
        Long loginUserCompanyId = SecurityFrameworkUtils.getLoginUserCompanyId();
        if (templateInstanceDataMapper.selectCount(new LambdaQueryWrapper<TemplateInstanceDataDO>()
                .eq(TemplateInstanceDataDO::getFldKy,createReqVO.getFldKy())
                .eq(TemplateInstanceDataDO::getInscId,createReqVO.getInscId())
                .eq(TemplateInstanceDataDO::getCompanyId,loginUserCompanyId)) >0) {
            throw exception(TMPL_INS_FLD_CODE_EXISTS);
        }
        // 插入
        TemplateInstanceDataDO templateInstanceData = BeanUtils.toBean(createReqVO, TemplateInstanceDataDO.class);
        templateInstanceDataMapper.insert(templateInstanceData);
        log.info("创建实例与字段值关系成功，结果：{}", templateInstanceData);
        // 返回
        return BeanUtils.toBean(templateInstanceData, TemplateInstanceDataRespVO.class);
    }

    @Override
    public void updateTemplateInstanceData(TemplateInstanceDataSaveReqVO updateReqVO) {
        // 校验存在
        validateTemplateInstanceDataExists(updateReqVO.getId());
        // 更新
        TemplateInstanceDataDO updateObj = BeanUtils.toBean(updateReqVO, TemplateInstanceDataDO.class);
        templateInstanceDataMapper.updateById(updateObj);
        log.info("更新实例与字段值关系成功，结果：{}", updateObj);
    }

    @Override
    public void deleteTemplateInstanceData(Long id) {
        // 校验存在
        validateTemplateInstanceDataExists(id);
        // 删除
        templateInstanceDataMapper.deleteById(id);
        log.info("删除实例与字段值关系成功，结果：{}", id);
    }

    @Override
        public void deleteTemplateInstanceDataListByIds(List<Long> ids) {
        // 校验存在
        validateTemplateInstanceDataExists(ids);
        // 删除
        templateInstanceDataMapper.deleteByIds(ids);
        log.info("删除实例与字段值关系成功，结果：{}", ids);
        }

    private void validateTemplateInstanceDataExists(List<Long> ids) {
        List<TemplateInstanceDataDO> list = templateInstanceDataMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(TEMPLATE_INSTANCE_DATA_NOT_EXISTS);
        }
    }

    private void validateTemplateInstanceDataExists(Long id) {
        if (templateInstanceDataMapper.selectById(id) == null) {
            throw exception(TEMPLATE_INSTANCE_DATA_NOT_EXISTS);
        }
    }

    @Override
    public TemplateInstanceDataDO getTemplateInstanceData(Long id) {
        return templateInstanceDataMapper.selectById(id);
    }

    @Override
    public PageResult<TemplateInstanceDataDO> getTemplateInstanceDataPage(TemplateInstanceDataPageReqVO pageReqVO) {
        log.info("查询实例与字段值关系列表，参数：{}", pageReqVO);
        return templateInstanceDataMapper.selectPage(pageReqVO);
    }

    @Override
    @Transactional
    public boolean setTemplateInstanceData(List<TemplateInstanceDataDO> pageReqVOS) {
        if (CollUtil.isEmpty(pageReqVOS)) {
           throw exception(PARAMS_IS_NULL_OR_ERR);
        }
        pageReqVOS.forEach(
                i->{templateInstanceDataMapper.updateFldValById(i.getInscId(),i.getFldVal(),i.getFldKy());
                    log.info("更新实例与字段值关系成功，结果：实例id：【{}】,key:【{}】,值【{}】", i.getInscId(),i.getFldKy(),i.getFldVal());
                });
        return true;
    }

    @Override
    @Transactional
    public boolean clearTemplateInstanceData(String instanceId, List<Long> valIds) {
        if (CollUtil.isEmpty(valIds)|| instanceId.isEmpty()) {
            throw exception(PARAMS_IS_NULL_OR_ERR);
        }
        int update = templateInstanceDataMapper.update(new LambdaUpdateWrapper<TemplateInstanceDataDO>().eq(TemplateInstanceDataDO::getInscId, instanceId).in(TemplateInstanceDataDO::getFldKy).set(TemplateInstanceDataDO::getFldVal, ""));
        if (valIds.size()!= update){
            throw exception(OPERATION_FAIL);
        }
        return  true;
    }

    @Override
    public List<TemplateInstanceDataRespVO> createBatchTemplateInstanceData(List<TemplateInstanceDataSaveReqVO> createReqVOS) {
        if (CollUtil.isEmpty(createReqVOS)) {
            throw exception(PARAMS_IS_NULL_OR_ERR);
        }
        List<TemplateInstanceDataDO> templateInstanceDataDOList = BeanUtils.toBean(createReqVOS, TemplateInstanceDataDO.class);
        templateInstanceDataMapper.insertBatch(templateInstanceDataDOList);
        return  BeanUtils.toBean(templateInstanceDataDOList, TemplateInstanceDataRespVO.class);
    }


}
